## fcitx5 5.0.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.0)
project(fcitx VERSION 5.0.18)
set(FCITX_VERSION ${PROJECT_VERSION})

find_package(ECM REQUIRED 1.0.0)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})

#######################################################################
# CMake macros
#######################################################################
include(FeatureSummary)
include(GNUInstallDirs)
include(ECMSetupVersion)
include(GenerateExportHeader)
include(WriteBasicConfigVersionFile)
include(ECMUninstallTarget)
include(src/lib/fcitx-utils/Fcitx5Macros.cmake)
include(CheckSymbolExists)

#######################################################################
# Options
#######################################################################
option(ENABLE_TEST "Build Test" On)
option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
set(GCOV_TOOL "gcov" CACHE STRING "Path to gcov tool used by coverage.")
set(DEFAULT_XKB_RULES "evdev" CACHE STRING "Xkb rules name")
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_X11 "Enable X11 support" On)
option(ENABLE_WAYLAND "Enable wayland support" On)
option(ENABLE_DBUS "Enable DBus" On)
option(ENABLE_DOC "Build doxygen" Off)
option(ENABLE_SERVER "Build a fcitx as server, disable this option if you want to use fcitx as an embedded library." On)
option(ENABLE_KEYBOARD "Enable key event translation with XKB and build keyboard engine" On)
option(USE_SYSTEMD "Use systemd for event loop and dbus, will fallback to libevent/libdbus if not found." On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installation" On)
option(USE_FLATPAK_ICON "Use flatpak icon name for desktop files" Off)
set(CLDR_DIR "" CACHE STRING "Unicode CLDR (Common Locale Data Repository) directory")
option(ENABLE_EMOJI "Enable emoji loading for CLDR" On)
option(ENABLE_LIBUUID "Use libuuid for uuid generation" On)
set(NO_PREEDIT_APPS "gvim.*,wps.*,wpp.*,et.*" CACHE STRING "Disable preedit for follwing app by default.")

if (CLDR_DIR STREQUAL "")
    if (IS_DIRECTORY "${CMAKE_INSTALL_FULL_DATADIR}/unicode/cldr")
        set(CLDR_DIR "${CMAKE_INSTALL_FULL_DATADIR}/unicode/cldr")
    else(IS_DIRECTORY "/usr/share/unicode/cldr")
        set(CLDR_DIR "/usr/share/unicode/cldr")
    endif()
endif()

set(EMOJI_FOUND FALSE)
if (ENABLE_EMOJI)
    if (CLDR_DIR STREQUAL "" OR NOT IS_DIRECTORY "${CLDR_DIR}/common/annotations/")
        message(WARNING "Could not find Unicode CLDR Annotation directory")
    else()
        set(EMOJI_FOUND TRUE)
    endif()
endif()

if ((ENABLE_WAYLAND OR ENABLE_X11) AND NOT ENABLE_KEYBOARD)
    message(FATAL_ERROR "X11 and Wayland require ENABLE_KEYBOARD to be set to ON.")
endif ()


#######################################################################
# Find packages
#######################################################################

find_package(PkgConfig REQUIRED)

if (USE_SYSTEMD)
find_package(Systemd)
endif ()

if (USE_FLATPAK_ICON)
    set(FCITX_ICON_NAME "org.fcitx.Fcitx5")
else()
    set(FCITX_ICON_NAME "fcitx")
endif()

if (NOT TARGET Systemd::Systemd)
    if (ENABLE_DBUS)
        pkg_check_modules(DBus REQUIRED IMPORTED_TARGET "dbus-1")
        pkg_get_variable(DBUS_SYSTEM_BUS_DEFAULT_ADDRESS "dbus-1" "system_bus_default_address")
    endif()

    if (NOT (TARGET libevent::core OR TARGET PkgConfig::LibEvent))
        find_package(Libevent)
    endif()
    if (TARGET libevent::core)
        set(LIBEVENT_TARGET libevent::core)
    else()
        pkg_check_modules(LibEvent REQUIRED IMPORTED_TARGET "libevent_core")
        set(LIBEVENT_TARGET PkgConfig::LibEvent)
    endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD|DragonFly")
    find_package(LibKVM REQUIRED)
endif()
find_package(DL REQUIRED)

if (NOT TARGET LibIntl::LibIntl)
    find_package(LibIntl REQUIRED)
endif()

if (ENABLE_LIBUUID)
    find_package(LibUUID REQUIRED)
endif()

find_package(Pthread REQUIRED)
find_package(Execinfo)
find_package(Gettext REQUIRED)

if (NOT (TARGET fmt::fmt OR TARGET fmt::fmt-header-only))
    find_package(fmt REQUIRED)
endif()

if (TARGET fmt::fmt-header-only)
  set(FMT_TARGET fmt::fmt-header-only)
else()
  set(FMT_TARGET fmt::fmt)
endif ()

set(REQUIRED_XKBCOMMON_COMPONENTS XKBCommon)
if (ENABLE_X11)
    set(REQUIRED_XKBCOMMON_COMPONENTS ${REQUIRED_XKBCOMMON_COMPONENTS} X11)
    find_package(XCB REQUIRED COMPONENTS XCB AUX XKB XFIXES ICCCM XINERAMA RANDR EWMH KEYSYMS)
    find_package(XCBImdkit 1.0.3 REQUIRED)
    pkg_check_modules(CairoXCB REQUIRED IMPORTED_TARGET cairo-xcb)
    pkg_check_modules(XkbFile REQUIRED IMPORTED_TARGET "xkbfile")
endif()

if (EMOJI_FOUND OR ENABLE_KEYBOARD)
    find_package(Expat REQUIRED)
endif()

if (ENABLE_KEYBOARD)
    find_package(XKBCommon REQUIRED COMPONENTS ${REQUIRED_XKBCOMMON_COMPONENTS})
    find_package(IsoCodes REQUIRED)
    find_package(XKeyboardConfig REQUIRED)
    pkg_check_modules(JsonC REQUIRED IMPORTED_TARGET "json-c")

    set(DEFAULT_XKB_RULES_FILES "${XKEYBOARDCONFIG_XKBBASE}/rules/${DEFAULT_XKB_RULES}.xml")
    if (NOT EXISTS "${DEFAULT_XKB_RULES_FILES}")
    message(FATAL_ERROR "Could not find default xkb rules file: ${DEFAULT_XKB_RULES_FILES}")
    endif()
endif()

# Library for classicui painting
if (ENABLE_X11 OR ENABLE_WAYLAND)
    pkg_check_modules(Cairo IMPORTED_TARGET cairo)
    pkg_check_modules(Pango IMPORTED_TARGET pango pangocairo)
    pkg_check_modules(GdkPixbuf IMPORTED_TARGET gdk-pixbuf-2.0)
    pkg_check_modules(GioUnix IMPORTED_TARGET gio-unix-2.0)
endif()

if (ENABLE_WAYLAND)
    set(REQUIRED_WAYLAND_COMPONENTS Client)
    find_package(Wayland REQUIRED COMPONENTS ${REQUIRED_WAYLAND_COMPONENTS})
    find_package(WaylandScanner REQUIRED)
    find_package(WaylandProtocols REQUIRED)
    pkg_check_modules(Gio IMPORTED_TARGET gio-2.0)
endif()

if(ENABLE_ENCHANT)
  pkg_check_modules(Enchant IMPORTED_TARGET "enchant-2")
  if(NOT TARGET PkgConfig::Enchant)
    pkg_check_modules(Enchant IMPORTED_TARGET "enchant" REQUIRED)
  endif()
endif()

if (TARGET Wayland::Client AND ENABLE_WAYLAND)
    set(WAYLAND_FOUND TRUE)
else()
    set(WAYLAND_FOUND FALSE)
endif()

# directory needed by bsd
if(NOT CMAKE_INSTALL_LIBDATADIR)
  set(CMAKE_INSTALL_LIBDATADIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "libdata root (LIBDIR)")
endif()

get_filename_component(CMAKE_INSTALL_FULL_LIBDATADIR "${CMAKE_INSTALL_LIBDATADIR}" ABSOLUTE)
mark_as_advanced(CMAKE_INSTALL_LIBDATADIR)
mark_as_advanced(CMAKE_INSTALL_FULL_LIBDATADIR)

include(Fcitx5CompilerSettings)

set(FCITX_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(FCITX_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(FCITX_INSTALL_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})
set(FCITX_INSTALL_LIBDATADIR ${CMAKE_INSTALL_FULL_LIBDATADIR})
set(FCITX_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(FCITX_INSTALL_DATADIR ${CMAKE_INSTALL_FULL_DATADIR})
set(FCITX_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/fcitx5")
set(FCITX_INSTALL_BINDIR ${CMAKE_INSTALL_FULL_BINDIR})
set(FCITX_INSTALL_LOCALEDIR ${CMAKE_INSTALL_FULL_LOCALEDIR})
set(FCITX_INSTALL_ADDONDIR "${CMAKE_INSTALL_FULL_LIBDIR}/fcitx5")
set(FCITX_INSTALL_CMAKECONFIG_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")
set(FCITX_INSTALL_MODULE_HEADER_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/Fcitx5/Module/fcitx-module")
# TODO mac/win
set(FCITX_LIBRARY_SUFFIX ".so")

check_function_exists(pipe2 HAVE_PIPE2)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(testing)

#######################################################################
# Test features
#######################################################################
if (ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)

    if (ENABLE_COVERAGE)
        add_custom_target(coverage
                        COMMAND "${CMAKE_CTEST_COMMAND}"
                        COMMAND lcov --gcov-tool "${GCOV_TOOL}" --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                        COMMAND genhtml coverage.info --output-directory "coverage_pages"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
endif ()

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(addon)

set(FCITX_UTILS_TEST
    testflags
    teststringutils
    testkey
    testutf8
    testcolor
    testi18nstring
    testevent
    testlist
    testfs
    testlibrary
    teststandardpath
    testunixfd
    testmetastring
    testhandlertable
    testsignals
    testinputbuffer
    testlog
    testeventdispatcher
    testrect
    testfallbackuuid
    testsemver)

set(FCITX_UTILS_DBUS_TEST
    testdbusmessage
    testdbus
    testservicewatcher)

set(testdbus_LIBS Pthread::Pthread)
set(testeventdispatcher_LIBS Pthread::Pthread)

find_program(XVFB_BIN Xvfb)

add_executable(XvfbWrapper IMPORTED)
set_target_properties(XvfbWrapper PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/xvfb_wrapper.sh")

if (ENABLE_DBUS)
    find_program(DBUS_DAEMON_BIN dbus-daemon)
    add_executable(DBusWrapper IMPORTED)
    set_target_properties(DBusWrapper PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/dbus_wrapper.sh")

    foreach(TESTCASE ${FCITX_UTILS_DBUS_TEST})
        add_executable(${TESTCASE} ${TESTCASE}.cpp)
        target_link_libraries(${TESTCASE} Fcitx5::Utils ${${TESTCASE}_LIBS})

        if (DBUS_DAEMON_BIN)
            add_test(NAME ${TESTCASE}
                    COMMAND DBusWrapper "${DBUS_DAEMON_BIN}" "${CMAKE_CURRENT_BINARY_DIR}/${TESTCASE}" ${${TESTCASE}_ARGS})
        endif()
    endforeach()
endif()

foreach(TESTCASE ${FCITX_UTILS_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Utils ${${TESTCASE}_LIBS})
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE} ${${TESTCASE}_ARGS})
endforeach()
set_target_properties(testlibrary PROPERTIES LINK_FLAGS "-rdynamic")

set(FCITX_CONFIG_TEST
    testconfig)

if (ENABLE_DBUS)
    list(APPEND FCITX_CONFIG_TEST testconfigdbus)
endif()

foreach(TESTCASE ${FCITX_CONFIG_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Config)
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

set(FCITX_CORE_TEST
    testinputcontext
    testsurroundingtext
    testaddon
    testmenu
    testuserinterfacemanager
    testelement
    testcandidatelist
    testicontheme
    testtext
    testinstance)

foreach(TESTCASE ${FCITX_CORE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Core ${${TESTCASE}_LIBS})
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE} ${${TESTCASE}_ARGS})
endforeach()

add_dependencies(testaddon dummyaddon)

if (ENABLE_KEYBOARD)
    add_executable(testxkbrules testxkbrules.cpp ../src/im/keyboard/xkbrules.cpp ../src/im/keyboard/xmlparser.cpp)
    target_compile_definitions(testxkbrules PRIVATE "-D_TEST_XKBRULES")
    target_include_directories(testxkbrules PRIVATE ../src)
    target_link_libraries(testxkbrules Fcitx5::Core Expat::Expat)
    add_test(NAME testxkbrules COMMAND testxkbrules)

    add_executable(testisocodes testisocodes.cpp ../src/im/keyboard/isocodes.cpp)
    target_compile_definitions(testisocodes PRIVATE "-D_TEST_XKBRULES")
    target_include_directories(testisocodes PRIVATE ../src)
    target_link_libraries(testisocodes Fcitx5::Core PkgConfig::JsonC)
    add_test(NAME testisocodes COMMAND testisocodes)

    add_executable(testcompose testcompose.cpp)
    target_link_libraries(testcompose Fcitx5::Core Fcitx5::Module::TestFrontend XKBCommon::XKBCommon keyboard)
    add_test(NAME testcompose COMMAND testcompose)
endif()

if (TARGET emoji)
add_executable(testemoji testemoji.cpp)
target_link_libraries(testemoji Fcitx5::Core Fcitx5::Module::Emoji)
add_dependencies(testemoji emoji emoji.conf.in-fmt)
add_test(NAME testemoji COMMAND testemoji)
endif()

add_executable(testunicode testunicode.cpp)
target_link_libraries(testunicode Fcitx5::Core Fcitx5::Module::TestFrontend Fcitx5::Module::TestIM)
add_dependencies(testunicode copy-addon unicode testui testfrontend testim)
add_test(NAME testunicode COMMAND testunicode)

add_executable(testquickphrase testquickphrase.cpp)
target_link_libraries(testquickphrase Fcitx5::Core Fcitx5::Module::QuickPhrase Fcitx5::Module::TestFrontend Fcitx5::Module::TestIM)
add_dependencies(testquickphrase copy-addon quickphrase testui testfrontend testim)
add_test(NAME testquickphrase COMMAND testquickphrase)

if (ENABLE_X11)
add_executable(testxim testxim.cpp)
target_link_libraries(testxim Fcitx5::Core Fcitx5::Module::TestIM Pthread::Pthread XCB::XCB XCB::AUX XCBImdkit::XCBImdkit)
add_dependencies(testxim copy-addon xim testui testfrontend testim)

# FIXME: Test may fail on some system
#if (XVFB_BIN)
#    add_test(NAME testxim COMMAND XvfbWrapper "${XVFB_BIN}" "${CMAKE_CURRENT_BINARY_DIR}/testxim")
#endif()
endif()

=== test/addon/CMakeLists.txt ===
add_library(dummyaddon MODULE dummyaddon.cpp)
target_link_libraries(dummyaddon Fcitx5::Core)

add_custom_target(copy-addon DEPENDS unicode.conf.in-fmt quickphrase.conf.in-fmt xim.conf.in-fmt xcb.conf.in-fmt)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/src/modules/unicode/unicode.conf ${CMAKE_CURRENT_BINARY_DIR}/unicode.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/src/modules/quickphrase/quickphrase.conf ${CMAKE_CURRENT_BINARY_DIR}/quickphrase.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/src/frontend/xim/xim.conf ${CMAKE_CURRENT_BINARY_DIR}/xim.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/src/modules/xcb/xcb.conf ${CMAKE_CURRENT_BINARY_DIR}/xcb.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/src/im/keyboard/keyboard.conf ${CMAKE_CURRENT_BINARY_DIR}/keyboard.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/testing/testfrontend/testfrontend.conf ${CMAKE_CURRENT_BINARY_DIR}/testfrontend.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/testing/testim/testim.conf ${CMAKE_CURRENT_BINARY_DIR}/testim.conf)
add_custom_command(TARGET copy-addon COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/testing/testui/testui.conf ${CMAKE_CURRENT_BINARY_DIR}/testui.conf)

=== src/modules/emoji/CMakeLists.txt ===
if (EMOJI_FOUND)
    add_library(emoji MODULE emoji.cpp ../../im/keyboard/xmlparser.cpp)
    target_link_libraries(emoji Fcitx5::Core Expat::Expat)
    install(TARGETS emoji DESTINATION "${FCITX_INSTALL_ADDONDIR}")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/emoji.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
            COMPONENT config)
endif()

configure_file(emoji.conf.in.in emoji.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/emoji.conf.in emoji.conf)
fcitx5_export_module(Emoji TARGET emoji BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS emoji_public.h INSTALL)

=== src/modules/spell/CMakeLists.txt ===
set(SPELL_SOURCES
    spell.cpp spell-custom-dict.cpp spell-custom.cpp)

if (TARGET PkgConfig::Enchant)
    set(SPELL_SOURCES ${SPELL_SOURCES} spell-enchant.cpp)
endif()

add_subdirectory(dict)
add_library(spell MODULE ${SPELL_SOURCES})
target_link_libraries(spell Fcitx5::Core)
if (TARGET PkgConfig::Enchant)
    target_link_libraries(spell PkgConfig::Enchant)
endif()
install(TARGETS spell DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(spell.conf.in.in spell.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/spell.conf.in spell.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/spell.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)
fcitx5_export_module(Spell TARGET spell BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS spell_public.h INSTALL)

=== src/ui/classic/CMakeLists.txt ===
add_subdirectory(themes)

set(CLASSICUI_WAYLAND_SRCS)
set(CLASSICUI_WAYLAND_LIBS)
if (WAYLAND_FOUND)
    set(CLASSICUI_WAYLAND_SRCS ${CLASSICUI_WAYLAND_SRCS}
        waylandui.cpp waylandwindow.cpp waylandshmwindow.cpp
        waylandpointer.cpp buffer.cpp waylandinputwindow.cpp)
    set(CLASSICUI_WAYLAND_LIBS ${CLASSICUI_WAYLAND_LIBS}
        Fcitx5::Module::Wayland Fcitx5::Module::WaylandIM Wayland::Client Fcitx5::Wayland::Core
        Fcitx5::Wayland::InputMethod Fcitx5::Wayland::InputMethodV2)
else()
endif()

if (ENABLE_X11)
    set(CLASSICUI_WAYLAND_SRCS ${CLASSICUI_WAYLAND_SRCS}
        xcbui.cpp xcbwindow.cpp xcbtraywindow.cpp xcbinputwindow.cpp xcbmenu.cpp)
    set(CLASSICUI_WAYLAND_LIBS ${CLASSICUI_WAYLAND_LIBS} PkgConfig::CairoXCB Fcitx5::Module::XCB
        XCB::AUX XCB::ICCCM XCB::XINERAMA XCB::RANDR XCB::EWMH)
endif()

add_library(classicui MODULE
    classicui.cpp window.cpp theme.cpp inputwindow.cpp plasmathemewatchdog.cpp ${CLASSICUI_WAYLAND_SRCS}
    )

target_link_libraries(classicui
    Fcitx5::Core
    PkgConfig::Cairo PkgConfig::Pango
    PkgConfig::GdkPixbuf PkgConfig::GioUnix
    Fcitx5::Module::NotificationItem
    ${CLASSICUI_WAYLAND_LIBS}
    ${FMT_TARGET})
install(TARGETS classicui DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(classicui.conf.in.in classicui.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/classicui.conf.in classicui.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/classicui.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)

fcitx5_export_module(ClassicUI TARGET classicui BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS classicui_public.h)

=== debian/changelog ===
fcitx5 (5.0.18-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 03 Jul 2022 21:44:59 -0400

fcitx5 (5.0.17-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jun 2022 14:13:54 -0400

fcitx5 (5.0.16-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 23 May 2022 16:45:41 -0400

fcitx5 (5.0.15-2) unstable; urgency=medium

  * debian/control: Recommend installation of fcitx5-frontend-qt6.
  * debian/copyright: Correct Source field with GitHub project.

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Apr 2022 10:08:26 -0400

fcitx5 (5.0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 16 Mar 2022 06:32:54 -0400

=== debian/control ===
Source: fcitx5
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 appstream,
 cmake (>= 3.6.0),
 dbus <!nocheck>,
 debhelper-compat (= 13),
 extra-cmake-modules,
 gettext,
 iso-codes,
 libbrotli-dev,
 libcairo2-dev,
 libdbus-1-dev [!linux-any],
 libegl1-mesa-dev,
 libenchant-2-dev,
 libevent-dev [!linux-any],
 libexpat1-dev,
 libfmt-dev,
 libgdk-pixbuf2.0-dev,
 libjson-c-dev,
 libkvm-dev [kfreebsd-any],
 libpango1.0-dev,
 libsystemd-dev [linux-any],
 libwayland-bin [linux-any],
 libwayland-dev [linux-any],
 libwayland-egl-backend-dev [linux-any],
 libxcb-ewmh-dev,
 libxcb-icccm4-dev,
 libxcb-imdkit-dev (>= 1.0.1~),
 libxcb-randr0-dev,
 libxcb-shape0-dev,
 libxcb-xfixes0-dev,
 libxcb-xinerama0-dev,
 libxcb-xkb-dev,
 libxcb1-dev,
 libxkbcommon-x11-dev,
 libxkbfile-dev,
 pkg-config,
 unicode-cldr-core,
 uuid-dev,
 wayland-protocols [linux-any],
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/fcitx5
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5

Package: fcitx5
Architecture: any
Depends:
 fcitx5-data (= ${source:Version}),
 fcitx5-modules (= ${binary:Version}),
 libfcitx5config6 (= ${binary:Version}),
 libfcitx5core7 (= ${binary:Version}),
 libfcitx5utils2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fcitx5-config-qt,
 fcitx5-frontend-gtk3,
 fcitx5-frontend-gtk4,
 fcitx5-frontend-qt5,
 fcitx5-frontend-qt6,
 im-config (>= 0.44),
Suggests:
 fcitx5-chinese-addons,
 fcitx5-frontend-gtk2,
 kde-config-fcitx5,
Conflicts:
 fcitx (<< 1:5),
 fcitx-data (<< 1:5),
 fcitx-bin (<< 1:5),
Description: Next generation of Fcitx Input Method Framework
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides core fcitx5 framework files.

Package: fcitx5-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (common data files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides architecture-independent data files.

Package: fcitx5-module-emoji
Architecture: any
Multi-Arch: same
Depends:
 unicode-cldr-core,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 fcitx5-modules (<< 0.0~git20200312),
Replaces:
 fcitx5-modules (<< 0.0~git20200312),
Description: Fcitx Input Method Framework v5 (emoji module)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides emoji module for fcitx5.

Package: fcitx5-module-quickphrase
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (quickphrase module)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides quickphrase module for fcitx5.

Package: fcitx5-module-wayland
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (wayland modules)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides wayland-related modules for fcitx5.

Package: fcitx5-module-xorg
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (xorg modules)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides xorg-related modules for fcitx5.

Package: fcitx5-modules
Architecture: any
Multi-Arch: same
Depends:
 fcitx5-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fcitx5-module-emoji,
 fcitx5-module-quickphrase,
 fcitx5-module-wayland,
 fcitx5-module-xorg,
Breaks:
 fcitx5-module-dbus (<< 5.0.4-2),
 fcitx5-module-fcitx4 (<< 5.0.4-2),
 fcitx5-module-ibus (<< 5.0.4-2),
 fcitx5-module-kimpanel (<< 5.0.4-2),
Replaces:
 fcitx5-module-dbus (<< 5.0.4-2),
 fcitx5-module-fcitx4 (<< 5.0.4-2),
 fcitx5-module-ibus (<< 5.0.4-2),
 fcitx5-module-kimpanel (<< 5.0.4-2),
Provides:
 fcitx5-module-dbus,
 fcitx5-module-ibus,
 fcitx5-module-kimpanel,
Description: Fcitx Input Method Framework v5 (core modules)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides core modules for fcitx5 and depends on all
 input modules.

Package: fcitx5-modules-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 fcitx5-module-emoji (= ${binary:Version}),
 fcitx5-module-quickphrase (= ${binary:Version}),
 fcitx5-module-wayland (= ${binary:Version}),
 fcitx5-module-xorg (= ${binary:Version}),
 fcitx5-modules (= ${binary:Version}),
 libfcitx5core-dev (= ${binary:Version}),
 libfcitx5utils-dev (= ${binary:Version}),
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (input modules dev files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides development files for fcitx5 input modules.

Package: libfcitx5config-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfcitx5config6 (= ${binary:Version}),
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (config library dev files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides development files for fcitx5 config libraries.

Package: libfcitx5config6
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (config library)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides fcitx5 config libraries.

Package: libfcitx5core-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfcitx5config-dev (= ${binary:Version}),
 libfcitx5core7 (= ${binary:Version}),
 libfcitx5utils-dev (= ${binary:Version}),
 ${misc:Depends},
Description: Fcitx Input Method Framework v5 (core library dev files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides development files for fcitx5 core libraries.

Package: libfcitx5core7
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fcitx Input Method Framework v5 (core library)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .

## fcitx5 5.0.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.6.0)
-project(fcitx VERSION 5.0.18)
+project(fcitx VERSION 5.0.19)
 set(FCITX_VERSION ${PROJECT_VERSION})
 
 find_package(ECM REQUIRED 1.0.0)

=== debian/changelog ===
fcitx5 (5.0.19-1) unstable; urgency=medium

  * New upstream version 5.0.19.
  * debian/watch: Switch to upstream dict tarball.
  * debian/upstream/signing-key.asc: Added.
  * debian/copyright:
    + Update en_dict info accordingly.
    + Update org_kde_kwin_blur code info.
  * debian/patches/0001: Drop patch on altered en_dict path,
    no longer needed.

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Aug 2022 13:46:33 -0400
